define(
        [
            'jquery',
            'ko',
            'uiComponent',
            'Magento_Customer/js/customer-data',
            'underscore',
            'Magento_Ui/js/modal/modal',
            'mage/cookies',
            'mage/translate',
            'jquery/ui',
            'tabs'
        ],
        function ($, ko, Component, customerData, _, modal) {
            "use strict";
            return Component.extend({

                geoipData: {},
                initialize: function () {

                    window.filoblu_geoip.geoipclass = this;

                    var me = this;
                    // Cookie Var

                    this.geoipData["must_choose_country"] = ko.observable();
                    this.geoipData["must_choose_country"](!$.mage.cookies.get(window.filoblu_geoip.store_cookie_name) && window.filoblu_geoip_redirect_allowed);
                    this.geoipData["continentcountry"] = ko.observableArray([]);
                    this.populateArrayCountryContinent();
                    var geoipData = customerData.get('geoip-data');
                    this.update(geoipData());
                    geoipData.subscribe(function (updatedGeoIpData) {
                        this.update(updatedGeoIpData);
                    }, this);
                    customerData.reload(['geoip-data'], false);
                    var optionsPopup = {
                        type: 'popup',
                        responsive: true,
                        modalClass: 'geoipModal',
                        innerScroll: true,
                        autoOpen: (this.geoipData["must_choose_country"]()),
                        buttons: [],
                        closed: function () {
                            $(window.filoblu_geoip.popup_id).addClass("selected-step-first").removeClass("selected-step-second");
                        },
                        opened: function ($Event) {
                            if (me.geoipData["must_choose_country"]()) {
                                $('.modal-header button.action-close', $Event.srcElement).hide();
                            }
                        },
                        keyEventHandlers: {

                            escapeKey: function () {
                                if (me.geoipData["must_choose_country"]()) {
                                    return;
                                }
                            }
                        }
                    };

                    var popup = modal(optionsPopup, $(window.filoblu_geoip.popup_id));

                    if ((this.geoipData["must_choose_country"]())) {
                        $("body").addClass("geoip-popup-showing");
                    }

                    $("body").on('click', window.filoblu_geoip.current_choose_country_link, function (e) {
                        e.preventDefault();
                        $(window.filoblu_geoip.popup_id).removeClass("selected-step-second").addClass("selected-step-first");
                    });

                    $("body").on('click', window.filoblu_geoip.country_link, function (e) {
                        e.preventDefault();
                        me._countryAjax($(this).attr("href"), $(this).attr("data-store-id"), $(this).attr("data-country-id"), $(this).attr("data-country-name"));
                    });

                    $("body").on('click', window.filoblu_geoip.language_link, function (e) {

                        e.preventDefault();
                        me._languageAjax($(this).attr("href"), $(this).attr("data-store-id"), $(this).attr("data-country-id"));
                    });

                    $("body").on("click", window.filoblu_geoip.shipping_to_link, function (e) {
                        e.preventDefault();
                        $(window.filoblu_geoip.popup_id).modal("openModal");
                    });

//                    this.initAutocompleteSearch();

                    return this._super();
                },
                initAutocompleteSearch: function () {

                    if (this.geoipData["must_choose_country"]()) {
                        var countriesArr = $.map(window.filoblu_geoip.data_continent_country.continentcountry, function (el) {
                            return el;
                        });
                    } else {
                        var countriesArr = $.map(window.filoblu_geoip.data_continent_country.continentcountrytranslated, function (el) {
                            return el;
                        });
                    }

                    var me = this;

                    $("#search-countries").autocomplete({
                        source: countriesArr,
                        appendTo: ".ui-search-countries",
                        select: function (event, ui) {
                            me._countryAjax(ui.item.url, ui.item.store_id, ui.item.country_id, ui.item.label);
                        }

                    }).data("ui-autocomplete")._renderItem = function (ul, item) {
                        return $("<li>").data("item.autocomplete", item).append("<a href='#' data-country-id='" + item.country_id + "' data-store-id='" + item.store_id + "' data-country-name='" + item.label + "'>" + item.label + "</a>").appendTo(ul);
                    };
                },
                _countryAjax: function (url, store_id, country_id, country_name) {

                    var me = this;
                    $.ajax({
                        showLoader: true,
                        url: url + "geoip/change/country",
                        data: "store_id=" + store_id + "&country_id=" + country_id,
                        type: "POST",
                        dataType: 'json'
                    }).done(function (languages) {

                        if (languages.length == 1) {
                            window.location.href = languages[0].url;
                        } else {
                            var languageList = "";
                            languages.forEach(function (entry) {
                                var languageName = "";
                                if (me.geoipData["must_choose_country"]) {
                                    languageName = entry.name;
                                } else {
                                    languageName = $.mage.__(entry.name);
                                }

                                languageList += "<a class='language-link' href='" + entry.url + "' data-store-id='" + entry.store_id + "' data-country-id='" + entry.country_id + "' >" + languageName + "</a>";
                            });
                            $(window.filoblu_geoip.language_list_container).html(languageList);
                            $(window.filoblu_geoip.current_choose_country_link).html(country_name);
                            $(window.filoblu_geoip.popup_id).removeClass("selected-step-first").addClass("selected-step-second");
                        }
                    });
                },
                _languageAjax: function (url, store_id, country_id) {
                    $.ajax({
                        showLoader: true,
                        url: url + "geoip/change/language",
                        data: "store_id=" + store_id + "&country_id=" + country_id,
                        type: "POST",
                        dataType: 'json'
                    }).done(function (result) {

                        if (result) {
                            window.location.href = result.url;
                        }
                    });
                },

                update: function (updatedGeoipData) {
                    _.each(updatedGeoipData, function (value, key) {

                        if (!this.geoipData.hasOwnProperty(key)) {
                            this.geoipData[key] = ko.observable();
                        }
                        this.geoipData[key](value);
                    }, this);
                },
                afterRenderContinentList: function (elements, data) {
                    // Sorry for this

                    if (($(window.filoblu_geoip.continent_list_container).children().length / 2) === Object.keys(window.filoblu_geoip.data_continent_country.continentcountry).length) {
                        $(window.filoblu_geoip.continent_list_container).accordion(
                                {
                                    "openedState": "active",
                                    "collapsible": true,
                                    "animate": {"easing": "linear"},
                                    "active": false,
                                    "multipleCollapsible": false,
                                    "heightStyle": "content"
                                });
                    }

                },
                /**
                 * Get geoip data param by name.
                 * @param {String} name
                 * @returns {*}
                 */
                getGeoipParam: function (name) {
                    if (!_.isUndefined(name)) {
                        if (!this.geoipData.hasOwnProperty(name)) {
                            this.geoipData[name] = ko.observable();
                        }
                    }

                    return this.geoipData[name]();
                },
                translateText: function (text) {
                    return $.mage.__(text);
                },
                populateArrayCountryContinent: function () {

                    if (this.geoipData["must_choose_country"]()) {
                        var continentCountry = window.filoblu_geoip.data_continent_country.continentcountry;
                    } else {
                        var continentCountry = window.filoblu_geoip.data_continent_country.continentcountrytranslated;
                    }

                    this.geoipData["continentcountry"] = ko.observableArray([]);
                    _.each(continentCountry, function (continentData, continentName) {

                        var _continentData = ko.observableArray([]);
                        _.each(continentData.countries, function (countryData, countryName) {

                            _continentData.push({
                                countryName: countryName,
                                countryData: countryData
                            });
                        }, this);
                        this.geoipData["continentcountry"].push({
                            continentName: continentName,
                            continentData: _continentData
                        });
                    }, this);
                }


            });
        }
);